/*
Program: min-packing-v1.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: Nnӿ}j]˦@j]ACӿ}jeO10Ap̤֭n]˯ȥi]nC
		  B@zGnMwi઺Τ覡AC@ؤΧYMw@إ]ˤ覡C
		  ҡGn = 4 = 1+3 = 2+2 = 1+1+2 = 1+1+1+1ANi}j]ˬ
			a) 1ơA4\@
			b) 1\1ӡB2\3
			c) 1\2ӡB2\2
			d) 1\1ӡB2\1ӡB3\2
			e) 1\1ӡB2\1ӡB3\1ӡB4\1
		  `NWza)Pe)ꬰqpC
		  ]}j`ƩTwAл\WU]˯ȭnۦPAP]ˤ覡yPצtC
		  YpC@ؤι\m覡gAhiؤΥiǫβպAADYoѡC 
Notes: 1) zLƤΡAtۭqshapeƵcHѨMDһ  
	   2) U{XB@ҥHjӼƬpqA̫~⬰ue()
	   3) ĤJuʺAWv(dynamic programming)ޥAHdimension[]ثeҪ̨βպA 
*/

#include <stdio.h>

typedef struct {		/* ۭqshapeƵcAyzNQ]˪XΪ */ 
	int n;				/* ҧtj */ 
	int base;			/* ӧΪ̤j */ 
	int level;
	int faces;			/* Ϊ}j@ɱĲ */ 
	int circumference;	/* Ϊ̵ug  */ 
} shape; 

int indx = 0;	/* ܰ|ݤm */			
int elementStack[100] = {0};  /* H}C@|c */ 

/* Udimension[i]}jƬiUAثeҪ̨βպA(g̵u) */
shape dimension[100] = {{0,0,0,0,0},{1,1,1,0,4},{2,2,1,1,6},{3,3,1,2,8}}; /* lƴXΪ̨Τؤo */ 

shape bestDimension(int n, shape s) /* dimension[n]PǤJsΪֱA^ǦX᪺֫պA */
{
	shape result;		/* X᪺֫GAN@Ʀ^Ǫe */ 
	int   minBase, level, tmp;
	
	if (s.n == 0)	/* sOŪ */ 
		result = dimension[n];
	else { 			/* dimension[n]PǤJsֱAMws̨βպA */ 
		minBase = dimension[n].base <= s.base? dimension[n].base : s.base; /* pGӧOΪ̤p̡ANvTĲjpPg */ 
		result.n = n+s.n;	/* X᪺֫sΪt}j */ 
		result.faces = dimension[n].faces+s.faces + minBase; /* @ɱĲƱNW[ */
		result.base = dimension[n].base >= s.base? dimension[n].base : s.base; /* GӧOΪ̤j̬X᪺֫ */ 
		if (result.n % result.base == 0 && ((level = result.n / result.base) > result.base)) {
			tmp = result.base;
			result.base = level;
			result.level = tmp;
		}
		else
			result.level = dimension[n].level+s.level;	
		result.circumference = dimension[n].circumference + s.circumference - 2*minBase; /* X᪺֫sΪg */		
		//if ((dimension[result.n].n == 0) || (dimension[result.n].circumference > result.circumference))
		if ((dimension[result.n].n == 0) || (dimension[result.n].circumference > result.circumference) 
			|| (dimension[result.n].circumference == result.circumference && dimension[result.n].base < result.base)) /* YsպAudimension[]ҰOeAhs */ 
			dimension[result.n] = result;
	}		
	
	//printf("j = %d;  = %d; @ = %d; g = %d\n",result.n, result.base, result.faces, result.circumference);
	
	return result;
}

shape partition(int n, int element, int max)  /* n:ݤΪơBmax:̤jBaddend:ұĥΪѤ */
{
	int i;
	shape  result = {0,0,0,0,0};	/* ŪXΪ */ 
	static shape bestOne = {0,0,0,0,1000000}; /* YN^Ǫ̨βպAAw]gYWjƭȡAHNs */ 
	
	elementStack[indx++] = element;	/* ۷push()ʧ@ */ 
	
    if (n == 0) { /* wĲBLkAΡA|eX */ 
		for (i = indx-1; i > 0; i--) /* v@X֩ҦiΩҹXΪAGresult */ 
			result = bestDimension(elementStack[i],result);  
    	//printf("j = %d;  = %d; @ = %d; g = %d\n",result.n, result.base, result.faces, result.circumference);
    	if (bestOne.circumference > result.circumference) bestOne = result; 
	}
    else /* n > 0AN۩|i~ */
    	for (i = 1; i <= max && i <= n; i++) 
          	partition(n-i,i,i);
    
    indx--;	/* Ppop()ʧ@ */ 
    
	return bestOne;	/* ^ǳ̨ΧΪ */ 
}

int main()
{
	int   n, i, numCube; 
	shape bestLayout;

	printf("\n*** ̤p]˭nlH]q{ ***\n\nJ}j ==> ");
	scanf("%d",&n);
	bestLayout = partition(n,0,n);	
	printf("\n̤֥]˯ȭn = %d\n",bestLayout.circumference*10*10+2*n*10*10);
	
	printf("\n]ˤ覡\\YzơG\n");
	for (numCube = n, i = 1; numCube > 0; numCube -= bestLayout.base, i++) {
		bestLayout = dimension[numCube];
		printf("%dơA\\%dӿj\n",i,bestLayout.base); /* XdN"\\\"DA]h[\HקKxZ */ 
	}
	
	return 0; 
}
